package io.gitlab.jfronny.googlechat.api;

import java.util.HashMap;
import java.util.Map;

public enum Language {
    AUTO_DETECT("AUTO_DETECT", "auto"), ARABIC("ARABIC", "ar"), CHINESE_SIMPLIFIED("CHINESE_SIMPLIFIED", "zh-CN"),
    CHINESE_TRADITIONAL("CHINESE_TRADITIONAL", "zh-TW"), ENGLISH("ENGLISH", "en"), FILIPINO("FILIPINO", "tl"),
    FRENCH("FRENCH", "fr"), GERMAN("GERMAN", "de"), GREEK("GREEK", "el"), INDONESIAN("INDONESIAN", "id"),
    IRISH("IRISH", "ga"), ITALIAN("ITALIAN", "it"), JAPANESE("JAPANESE", "ja"), JAVANESE("JAVANESE", "jw"),
    KOREAN("KOREAN", "ko"), LATIN("LATIN", "la"), POLISH("POLISH", "pl"), PORTUGUESE("PORTUGUESE", "pt"),
    RUSSIAN("RUSSIAN", "ru"), SPANISH("SPANISH", "es"), SWEDISH("SWEDISH", "sv"), THAI("THAI", "th"),
    VIETNAMESE("VIETNAMESE", "vi");

    private static final Map<String, Language> LANGUAGE_BY_VALUE = new HashMap<>();

    static {
        for (Language language : Language.values()) {
            LANGUAGE_BY_VALUE.put(language.value, language);
        }
    }

    public static Language byValue(String value) {
        return LANGUAGE_BY_VALUE.getOrDefault(value, AUTO_DETECT);
    }

    public final String name;
    public final String value;

    Language(String name, String value) {
        this.name = name;
        this.value = value;
    }

    @Override
    public String toString() {
        return name;
    }
}
